;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Biblioteka procedur operujacych datami         **
;**                                                   **
;**              Andrzej Pawluczuk                    **
;**                                                   **
;**             Mikrokontroler: AVR                   **
;**                                                   **
;**               Bialystok, 2006                     **
;**                                                   **
;*******************************************************
;*******************************************************
;
;-----------------------------------------------------------------------------
.message	"***>>> Dolaczenie bibioteki obrobki dat"
;-----------------------------------------------------------------------------
.equ	Nie     =	1
.equ	Pon     =	2
.equ	Wto     =	3
.equ	Sro     =	4
.equ	Czw     =	5
.equ	Pia     =	6
.equ	Sob     =	0
;-----------------------------------------------------------------------------
DivModArg1By7 :					;PROCEDURE DivModArg1By7 ( ) ;
;*****************				;	Argument2 := Argument1 DIV 7 ;
;						;	WorkRegL := Argument1 MOD 7 ;
;						;	Argument1, Argument2 - 16 bit
;						;BEGIN (* DivModArg1By7 *)
	clr	acc				;
	mov	Argument2LL,acc			;
	mov	Argument2LH,acc			;
	mov	WorkRegLL,acc			;
	mov	WorkRegLH,acc			;
	ldi	acc,16				;
	mov	DivLoopCounter,acc		;
DiMo7_0	:					;
	lsl	Argument1LL			;
	rol	Argument1LH			;
	rol	WorkRegLL			;
	ldi	acc,7				;
	cp	WorkRegLL,acc			;
	brcs	DiMo7_3				;
DiMo7_2	:					;
	sec					;
	rol	Argument2LL			;
	rol	Argument2LH			;
	ldi	acc,7				;
	sub	WorkRegLL,acc			;
	rjmp	DiMo7_4				;
DiMo7_3	:					;
	lsl	Argument2LL			;
	rol	Argument2LH			;
DiMo7_4	:					;
	dec	DivLoopCounter			;
	brne	DiMo7_0				;
	ret					;END (* DivModArg1By7 *) ;
;-----------------------------------------------------------------------------
ConvDateToNumber :				;FUNCTION ConvDateToNumber ( Year[zh:zl] : WORD ;
;*****************				;		             Month[acc] : BYTE ;
;						;		             Day[param] : BYTE ) : WORD[X] ;
;						;VAR
;						; DResult[X] : WORD ;
;						; FebDays[acc2] : BYTE ;
;						;BEGIN (* ConvDateToNumber *)
	push	acc				;
	subi	zl,low(1900)			; Year := Year - 1900 ;
	sbci	zh,high(1900)			;
	rcall	MultBy365			; DResult := Year * 365 ;
	mov	acc2,zh				; DResult := DResult + ( Year / 4 ) ;
	mov	acc,zl				;
	rcall	_RSiftReg			;
	rcall	_RSiftReg			;
	add	xl,acc				;
	adc	xh,acc2				;
	mov	acc,zl				; IF ( Year MOD 4 ) <> 0 THEN
	andi	acc,0x03			;
	breq	ConDaToN_0			;  BEGIN
	ldi	acc2,28				;   FebDays := 28 ;
	adiw	xl,1				;   DResult := DResult + 1 ;
	rjmp	ConDaToN_1			;  END (* IF ... *)
ConDaToN_0:					; ELSE
						;  BEGIN
	ldi	acc2,29				;   FebDays := 29 ;
ConDaToN_1:					;  END (* IF ... ELSE *) ;
	pop	acc				; CASE Month OF
	cpi	acc,1				;  1 :
	brne	ConDaToN_C1			;   BEGIN
	rjmp	ConDaToN_CE			;    ;
ConDaToN_C1 :					;   END (* CASE VARIANT *) ;
	cpi	acc,2				;  2 :
	brne	ConDaToN_C2			;   BEGIN
	ldi	acc,31				;    DResult := DResult + 31 ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C2 :					;   END (* CASE VARIANT *) ;
	cpi	acc,3				;  3 :
	brne	ConDaToN_C3			;   BEGIN
	ldi	acc,31				;    DResult := DResult + 31 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C3 :					;   END (* CASE VARIANT *) ;
	cpi	acc,4				;  4 :
	brne	ConDaToN_C4			;   BEGIN
	ldi	acc,62				;    DResult := DResult + 62 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C4 :					;   END (* CASE VARIANT *) ;
	cpi	acc,5				;  5 :
	brne	ConDaToN_C5			;   BEGIN
	ldi	acc,92				;    DResult := DResult + 92 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C5 :					;   END (* CASE VARIANT *) ;
	cpi	acc,6				;  6 :
	brne	ConDaToN_C6			;   BEGIN
	ldi	acc,123				;    DResult := DResult + 123 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C6 :					;   END (* CASE VARIANT *) ;
	cpi	acc,7				;  7 :
	brne	ConDaToN_C7			;   BEGIN
	ldi	acc,153				;    DResult := DResult + 153 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C7 :					;   END (* CASE VARIANT *) ;
	cpi	acc,8				;  8 :
	brne	ConDaToN_C8			;   BEGIN
	ldi	acc,184				;    DResult := DResult + 184 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C8 :					;   END (* CASE VARIANT *) ;
	cpi	acc,9				;  9 :
	brne	ConDaToN_C9			;   BEGIN
	ldi	acc,215				;    DResult := DResult + 215 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C9 :					;   END (* CASE VARIANT *) ;
	cpi	acc,10				;  10 :
	brne	ConDaToN_C10			;   BEGIN
	ldi	acc,245				;    DResult := DResult + 245 + FebDays ;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	add	xl,acc2				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C10 :					;   END (* CASE VARIANT *) ;
	cpi	acc,11				;  11 :
	brne	ConDaToN_C11			;   BEGIN
	ldi	acc,low(276)			;    DResult := DResult + 276 + FebDays ;
	add	xl,acc				;
	ldi	acc,high(276)			;
	adc	xh,acc				;
	add	xl,acc2				;
	ldi	acc,0				;
	adc	xh,acc				;
	rjmp	ConDaToN_CE			;
ConDaToN_C11 :					;   END (* CASE VARIANT *) ;
	cpi	acc,12				;  12 :
	brne	ConDaToN_C12			;   BEGIN
	ldi	acc,low(306)			;    DResult := DResult + 306 + FebDays ;
	add	xl,acc				;
	ldi	acc,high(306)			;
	adc	xh,acc				;
	ldi	acc,0				;
	add	xl,acc2				;
	adc	xh,acc				;
;	rjmp	ConDaToN_CE			;
ConDaToN_C12 :					;   END (* CASE VARIANT *) ;
ConDaToN_CE :					; END (* CASE *) ;
	add	xl,param			; DResult := DResult + Day ;
	ldi	acc,0				;
	adc	xh,acc				;
	ret					; ConvDateToNumber := DResult ;
						;END (* ConvDateToNumber *) ;
MultBy365 :					;
	mov	xh,zh				; DResult := ( 256 + 64 + 32 + 8 + 4 + 1 ) * Year ;
	mov	xl,zl				;
	mov	acc2,zh				; ( + 1 ) 
	mov	acc,zl				;
	rcall	_LShiftReg			; ( + ( * 4 ) )
	rcall	_LShiftReg			;
	add	xl,acc				;
	adc	xh,acc2				;
	rcall	_LShiftReg			; ( + ( * 8 ) )
	add	xl,acc				;
	adc	xh,acc2				;
	rcall	_LShiftReg			; ( + ( * 32 ) )
	rcall	_LShiftReg			;
	add	xl,acc				;
	adc	xh,acc2				;
	rcall	_LShiftReg			; ( + ( * 64 ) )
	add	xl,acc				;
	adc	xh,acc2				;
	rcall	_LShiftReg			; ( + ( * 256 ) )
	rcall	_LShiftReg			;
	add	xl,acc				;
	adc	xh,acc2				;
	ret					;
_LShiftReg :					;
	lsl	acc				;
	rol	acc2				;
	ret					;
_RSiftReg :					;
	lsr	acc2				;
	ror	acc				;
	ret					;
;-----------------------------------------------------------------------------
DayOfWeek :					;FUNCTION DayOfWeek ( Year[zh:zl] : WORD ;
;**************					;		       Month[acc] : BYTE ;
;						;		       Day[param] ) : BYTE[acc] ;
;						;BEGIN (* DayOfWeek *)
	rcall	ConvDateToNumber		; DatyOfWeek := ConvDateToNumber ( Year , Month , Day ) MOD 7 ;
	mov	Argument1LL,xl			;
	mov	Argument1LH,xh			;
	rcall	DivModArg1By7			;
	mov	acc,WorkRegLL			;
	ret					;END (* DayOfWeek *) ;
;-----------------------------------------------------------------------------
.exit
